/* Event system */
/* Yes, all events are hardcoded with "name" as their identification.
   It's a small game, anyway. :) */

var events = [];


//Some standard stuff to prepare the engine for the event.
function EventStart()
{
  music.setVolume(128);
  platformsystem.reset();
  platformsystem.control = false;
  UpdateMapEngine();
}


function EventDone()
{
  music.setVolume(255);
  platformsystem.reset();
  platformsystem.control = true;
}

function Wait(frames)
{
  for (var i = 0; i < frames; i++)
    UpdateMapEngine(), RenderMap(), FlipScreen();
}


/**************************/
//       THE EVENTS
/**************************/

events["fell into an unknown world"] = function()
{
  music.stop();
  EventStart();
  SetRenderScript("Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), black);");
  storybox.show("INSTRUCTIONS", 30);
  nowindowbox.show("CTRL - jump / advance through text" +
                   "\nARROW KEYS - Walk / push boxes" +
                   "\nR - Restart level (if you get stuck)");
  SetRenderScript("RenderScript();");
  
  Wait(60);
  textbox.show("Damien: ...");
  Wait(60);
  SetPersonDirection("Damien", "west", true);
  Wait(60);
  SetPersonDirection("Damien", "east", true);
  Wait(50);
  SetPersonDirection("Damien", "west", true);
  Wait(50);
  SetPersonDirection("Damien", "east", true);
  textbox.show("Damien: Where the hell am I?");
  textbox.show("Damien: I just... fell into that hole and now I'm in some weird underground place?");
  SetPersonDirection("Damien", "west", true);
  Wait(60);
  textbox.show("Damien: Well, underground... It doesn't LOOK like I am underground... Strange.");
  SetPersonDirection("Damien", "east", true);
  textbox.show("Damien: Well, I'd better find a way back up. Who knows what mom and dad'll " +
               "think when I get home late.");
  Wait(60);
  
  //music.play(true);
  EventDone();
}


events["firstbox"] = function()
{
  if (events["firstbox"].happened) return;
  EventStart();
  
  textbox.show("Damien: Huh? What's this? Some sort of box?");
  textbox.show("Damien: It's in the way.");
  
  for (var i = 0; i < 64; i++)
  {
    if (i % 2 == 0)
      QueuePersonCommand("Damien", COMMAND_MOVE_EAST, true),
      QueuePersonCommand("Damien", COMMAND_ANIMATE, true);
    UpdateMapEngine(); RenderMap(); FlipScreen();
  }
  
  textbox.show("Damien: !!!");
  textbox.show("Damien: Ah, so I can move them around! Phew, I don't exactly wanna " +
               "get stuck down here...");
  textbox.show("Damien: Well, let's go.");
  
  EventDone();
  events["firstbox"].happened = true;
}


events["more boxes"] = function()
{
  if (events["more boxes"].happened) return;
  EventStart();
  textbox.show("Damien: Great. More boxes. Will I be moving those a lot?");
  EventDone();
  events["more boxes"].happened = true;
}


//Find the first heavy box.
events["heavy box"] = function()
{
  if (events["heavy box"].happened) return;
  EventStart();
  textbox.show("Damien: This box looks different...");
  for (var i = 0; i < 64; i++)
  {
    if (i % 2 == 0)
      QueuePersonCommand("Damien", COMMAND_MOVE_EAST, true),
      QueuePersonCommand("Damien", COMMAND_ANIMATE, true);
    UpdateMapEngine(); RenderMap(); FlipScreen();
  }
  textbox.show("Ugh, it's too heavy. I'll go around it.");
  EventDone();
  events["heavy box"].happened = true;
}

events["spiky box"] = function()
{
  if (events["spiky box"].happened) return;
  EventStart();
  textbox.show("Damien: These look dangerous. I'd better avoid them.");
  EventDone();
  events["spiky box"].happened = true;
}


events["light box"] = function()
{
  if (events["light box"].happened) return;
  EventStart();
  textbox.show("Damien: These boxes look light, I might be able to push more of them more easily...");
  EventDone();
  events["light box"].happened = true;
}


events["3 is too heavy"] = function()
{
  if (events["3 is too heavy"].happened || platformsystem.strength == 3) return;
  EventStart();
  textbox.show("Damien: Argh, this is getting too heavy!");
  textbox.show("Damien: Did I miss something before? I'm sure I saw a piece of meat or something...");
  EventDone();
  events["3 is too heavy"].happened = true;
}

/*
events["first button"] = function()
{
  if (events["first button"].happened) return;
  EventStart();
  textbox.show("Damien: A button and a digit... Perhaps I need to drop the right weight onto that button?");
  EventDone();
  events["first button"].happened = true;
}


events["gate"] = function()
{
  if (events["gate"].happened) return;
  EventStart();
  textbox.show("Damien: It looks like some sort of door. There's no door handle, though.");
  EventDone();
  events["gate"].happened = true;
}


events["springgiver"] = function()
{
  if (events["springgiver"].happened) return;
  EventStart();
  textbox.show("Shady character: Hey, want a spring? They help you get higher...");
  //var answer = YesNoQuestion.show();
  //if (answer)
  //{
  
  if (GEMS < 2)
    textbox.show("Shady character: If you want one, you'll have to bring me a few gems. " +
                 "Two'll do, I think.");
  else
  {
    textbox.show("Shady character: Nice doin' business with ya, heh heh.");
    GetJumpPowerup(1);
    for (var i = 0; i < 64; i++)
    {
      QueuePersonCommand("Damien", COMMAND_MOVE_WEST, true),
      QueuePersonCommand("Damien", COMMAND_ANIMATE, true);
      UpdateMapEngine(); RenderMap(); FlipScreen();
    }
    Wait(30);
    textbox.show("Damien: Creepy fella.");
    events["springgiver"].happened = true;
  }
  EventDone();
}*/


events["finish"] = function()
{
  Warp("end.rmp", 11, 15);
  platformsystem.jump(4);
  
  //Jump high out of the cave and move to the left.
  QueuePersonCommand(platformsystem.person, COMMAND_FACE_WEST, false);
  
  
  storybox.show("      *** CRAAAASSSSHHH ***", 60);
  Wait(30);
  
  textbox.show("Damien: Whooooaaaah!");
  textbox.show("Damien: I seem to have made it out of that weird cave. Awesome!");
  for (var i = 0; i < 256; i++)
    QueuePersonCommand(platformsystem.person, COMMAND_MOVE_WEST, false);
  
  SetRenderScript("Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), black);");
  storybox.show("And so, Damien Docchi had a little adventure in not-so-much-puzzle-land.", 180);
  storybox.show("I sure wish I had spent a bit more time making this game so there would have been more puzzles.", 240);
  storybox.show("Well, thanks for playing! See ya!", 180);
  storybox.show("(c) DaVince, 2009. Thanks to AndyUK for testing a bit.", 240);
  
  Wait(120);
  Exit();
}
