/** Semi-compo entry
    "Puzzle Platformer"
    By DaVince
    
    Please forgive the bad coding, it's been quite a while since I
    seriously coded a game, especially in Sphere! :)
**/

//Debugging stuff
var notalk = false;


//Main variables
var FPS = 60;
var LIVES = 10;
var STRENGTH_POWERUPS = [];  //An array filled with IDs matching the strength powerups.
var JUMP_POWERUPS = [];  //Same for jump powerups.
var GEMS = 0;
var MAP = []; //Keep some data on the map, like the remembered entry position.
MAP.name = "";
MAP.x = 0;
MAP.y = 0;

//Resources
var FONT = LoadFont("font.rfn");
var DEATHFONT = LoadFont("death.rfn");
var TEXTWINDOW = LoadWindowStyle("textwindow.rws");

var sounds = [];
sounds.powerup = LoadSound("powerup.ogg");
var music;

//Colors
var black = CreateColor(0, 0, 0);
var white = CreateColor(255, 255, 255);
var trans = CreateColor(0, 0, 0, 128);
var red = CreateColor(200, 30, 30);

//Keys
var KEY_ACCEPT = KEY_CTRL;
var KEY_JUMP = KEY_CTRL;

RequireScript("text.js");
var textbox = new TextBox();
var storybox = new TextBox(true, false);
var autotextbox = new TextBox(true);
var nowindowbox = new TextBox(false, false);

RequireScript("platform.js");
var platformsystem = new PlatformSystem("Damien");

RequireScript("event.js");
RequireScript("map.js");


//Overriding FlipScreen() to use a framerate regulator.
var time = GetTime();
var _FlipScreen = FlipScreen;
var FlipScreen = function()
{
  while(GetTime() <= time + 1000/FPS);
  time = GetTime();
  _FlipScreen();
}


function game()
{
  CreatePerson("Damien", "damien.rss", false);
  AttachCamera("Damien");
  AttachInput("Damien");
  BindKey(KEY_LEFT, "", "");
  BindKey(KEY_RIGHT, "", "");
  BindKey(KEY_UP, "", "");
  BindKey(KEY_DOWN, "", "");
  music = LoadSound("chip-something-serious.it");
  
  MAP.name = "map1.rmp";
  SetDefaultMapScript(SCRIPT_ON_ENTER_MAP, "MapEnter();");
  MapEngine(MAP.name, FPS);
}


function MapEnter()
{
  platformsystem.init();
  BindKey(KEY_R, "ChangeMap('" + GetCurrentMap() + "'); SetPersonX(platformsystem.person, platformsystem.enterx); SetPersonY(platformsystem.person, platformsystem.entery);", "");
  BindKey(KEY_D, "platformsystem.die();", "");
  SetRenderScript("RenderScript();");
  SetUpdateScript("UpdateScript();");
  InitMapItems();
}



function GetStrengthPowerup(id)
{
  //Cannot have the same powerup twice, so check for it.
  for (n in STRENGTH_POWERUPS)
  {
    if (STRENGTH_POWERUPS[n] == id)
      return;
  }
  //Otherwise, POWAHH UP!
  platformsystem.strength++;
  music.stop();
  sounds.powerup.play(false);
  autotextbox.show("You got a strength powerup!", 30);
  textbox.show("Your strength is now " + platformsystem.strength + ".\n" +
                   "You can push more horizontally stacked boxes now.");
  if (platformsystem.strength == 3)
    textbox.show("You can now also lift heavy (brown) boxes!");
  sounds.powerup.stop();
  //music.play(true);
  STRENGTH_POWERUPS.push(id);
  DestroyPerson("powerup-strength_" + id)
}



function GetJumpPowerup(id)
{
  //Cannot have the same powerup twice, so check for it.
  for (n in JUMP_POWERUPS)
  {
    if (JUMP_POWERUPS[n] == id)
      return;
  }
  //Otherwise, POWAHH UP!
  platformsystem.jumpstrength+=0.7;
  music.stop();
  sounds.powerup.play(false);
  autotextbox.show("You got a jump powerup!", 30);
  textbox.show("You'll be able to jump higher now.");
  sounds.powerup.stop();
  //music.play(true);
  JUMP_POWERUPS.push(id);
  DestroyPerson("powerup-jump_" + id);
}

