/** Textbox system **/

function TextBox(auto, windowstyle, font)
{
  this.auto = auto || false;
  this.window = (windowstyle == undefined) ? TEXTWINDOW : false;
  this.font = font || FONT;
  
  /** Render the background and textbox. */
  this.render = function(text)
  {
    if (IsMapEngineRunning()) UpdateMapEngine(), RenderMap();
    if (this.window) this.window.drawWindow(10, 10, 300, 48);
    this.font.drawTextBox(10, 10, 300, 48, 0, text);
    FlipScreen();
  }
  
  /** Show the textbox and wait for key input or the given time. */
  this.show = function(text, speed)
  {
		if (notalk) return;
		
    speed = (speed == undefined) ? 60 : speed;
    var curtext = "";
    var wasactive = platformsystem.active;
    platformsystem.active = false;
    
    for (var i = 0; i <= text.length; i+=(speed/FPS))
    {
      curtext = text.slice(0, Math.floor(i));
      this.render(curtext);
    }
    
    //Wait until 2 seconds passed or a key was pressed.
    if (this.auto)
      for (var i = 0; i < 120; i++) this.render(text);
    
    else
    {
      while (AreKeysLeft()) GetKey();  //Empty key queue.
      while (!IsKeyPressed(KEY_ACCEPT)) this.render(text);
    }
    if (wasactive) platformsystem.active = true;
  }
}

